

#include "BUILTIN.h"

#include "Denotation.h"

#include "NatConv.h"
extern OBJ _ACompose_4(OBJ,OBJ,OBJ);extern OBJ __ACompose_4;
extern OBJ _AGlobSig_46(OBJ);extern OBJ __AGlobSig_46;
extern OBJ _AGlobSig_50(OBJ);extern OBJ __AGlobSig_50;
extern OBJ _AGlobSig_51(OBJ);extern OBJ __AGlobSig_51;
extern OBJ _AGlobSig_52(OBJ);extern OBJ __AGlobSig_52;
extern OBJ _AGlobSig_55(OBJ);extern OBJ __AGlobSig_55;
extern OBJ _AGlobSig_56(OBJ);extern OBJ __AGlobSig_56;
extern OBJ _AGlobSig_57(OBJ);extern OBJ __AGlobSig_57;
extern OBJ _AGlobSig_58(OBJ);extern OBJ __AGlobSig_58;
extern OBJ _AGlobSig_93(OBJ);extern OBJ __AGlobSig_93;
extern OBJ _AGlobSig_94(OBJ);extern OBJ __AGlobSig_94;
extern OBJ _AGlobSig_95(OBJ);extern OBJ __AGlobSig_95;
extern TUP2 _AGlobSig_97(OBJ);extern OBJ __AGlobSig_97;
extern OBJ _AOptionConv_2(OBJ,OBJ);extern OBJ __AOptionConv_2;
extern OBJ _ATable_17(OBJ,OBJ,OBJ);extern OBJ __ATable_17;
extern OBJ _APairConv_3(OBJ,OBJ,OBJ);extern OBJ __APairConv_3;
extern OBJ __APairConv_5;
extern OBJ __APairConv_7;
extern OBJ _AUniqueTable_20(OBJ,OBJ,OBJ,OBJ);extern OBJ __AUniqueTable_20;
extern OBJ _AMapConv_8(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);extern OBJ __AMapConv_8;
extern OBJ __AMapConv_13;
extern OBJ __AMapConv_14;
extern OBJ __AMapConv_15;
extern OBJ _ADeclEntry_34(OBJ);extern OBJ __ADeclEntry_34;
extern OBJ _ASeqConv_2(OBJ,OBJ);extern OBJ __ASeqConv_2;
extern OBJ _ASeqConv_3(OBJ,OBJ,OBJ,OBJ,OBJ);extern OBJ __ASeqConv_3;
extern OBJ __ASeqConv_8;
extern OBJ _APartNameEntry_54(OBJ,OBJ);extern OBJ __APartNameEntry_54;
extern OBJ _APartNameEntry_55(OBJ,OBJ);extern OBJ __APartNameEntry_55;
extern OBJ _APartNameEntry_56(OBJ);extern OBJ __APartNameEntry_56;
extern OBJ _APartNameEntry_57(OBJ);extern OBJ __APartNameEntry_57;
extern OBJ _APartNameEntry_60(OBJ);extern OBJ __APartNameEntry_60;

#include "Int.h"
extern OBJ _AImpExpEntry_138(OBJ);extern OBJ __AImpExpEntry_138;

#include "Real.h"
extern OBJ _AObjects_18(OBJ);extern OBJ __AObjects_18;
extern OBJ _AObjects_22(OBJ);extern OBJ __AObjects_22;
extern OBJ _AObjects_26(OBJ);extern OBJ __AObjects_26;
extern OBJ _AName_34(OBJ);extern OBJ __AName_34;
extern OBJ _AGlobSigImpl_31(OBJ);extern OBJ __AGlobSigImpl_31;
extern OBJ _ARep_12(OBJ);extern OBJ __ARep_12;
extern OBJ _ARep_27(OBJ,OBJ);extern OBJ __ARep_27;
extern OBJ __ARep_187;
extern OBJ _APragma_10(OBJ);extern OBJ __APragma_10;
extern OBJ _AImpl_186(OBJ,OBJ);extern OBJ __AImpl_186;
extern OBJ _AGlobPragma_14(OBJ,OBJ);extern OBJ __AGlobPragma_14;

#include "Nat.h"

#include "Char.h"

#include "Bitset.h"

#include "Array.h"
extern OBJ _AGlobSigToText_1(OBJ,OBJ);OBJ __AGlobSigToText_1; /* ` */
extern OBJ _AGlobSigToText_2(OBJ);OBJ __AGlobSigToText_2; /* `_l */
extern OBJ _AGlobSigToText_3(OBJ);OBJ __AGlobSigToText_3; /* `,1 */
extern OBJ _AGlobSigToText_4(OBJ);OBJ __AGlobSigToText_4; /* `,2 */
extern OBJ _AGlobSigToText_5(OBJ);OBJ __AGlobSigToText_5; /* `,3 */
OBJ __AGlobSigToText_6; /* c */
OBJ __AGlobSigToText_7; /* `,1'7 */
OBJ __AGlobSigToText_8; /* `,1'8 */
extern OBJ _AGlobSigToText_9(OBJ);OBJ __AGlobSigToText_9; /* `,3'9 */
extern OBJ _AGlobSigToText_10(OBJ);OBJ __AGlobSigToText_10; /* `,3'10 */
extern OBJ _AGlobSigToText_11(OBJ);OBJ __AGlobSigToText_11; /* `,3'11 */
OBJ __AGlobSigToText_12; /* `,3'12 */
extern OBJ _AGlobSigToText_13(OBJ);OBJ __AGlobSigToText_13; /* `,3'13 */
extern OBJ _AGlobSigToText_14(OBJ);OBJ __AGlobSigToText_14; /* `,3'14 */
OBJ __AGlobSigToText_15; /* `'15 */
OBJ __AGlobSigToText_16; /* `'16 */
OBJ __AGlobSigToText_17; /* `'17 */
OBJ __AGlobSigToText_18; /* `'18 */
OBJ __AGlobSigToText_19; /* `'19 */
OBJ __AGlobSigToText_20; /* `'20 */
OBJ __AGlobSigToText_21; /* `'21 */
OBJ __AGlobSigToText_22; /* `'22 */
extern OBJ _AGlobSigToText_23(OBJ);OBJ __AGlobSigToText_23; /* `'23 */
OBJ __AGlobSigToText_24; /* `'24 */
extern OBJ _AGlobSigToText_25(OBJ);OBJ __AGlobSigToText_25; /* `'25 */
OBJ __AGlobSigToText_26; /* `'26 */
extern OBJ _AGlobSigToText_27(OBJ);OBJ __AGlobSigToText_27; /* `'27 */
extern OBJ _AGlobSigToText_28(OBJ);OBJ __AGlobSigToText_28; /* `'28 */
extern OBJ _AGlobSigToText_29(OBJ);OBJ __AGlobSigToText_29; /* `'29 */
OBJ __AGlobSigToText_30; /* `'30 */
OBJ __AGlobSigToText_31; /* `'31 */
OBJ __AGlobSigToText_32; /* `'32 */
OBJ __AGlobSigToText_33; /* `'33 */
OBJ __AGlobSigToText_34; /* `'34 */
OBJ __AGlobSigToText_35; /* `'35 */
OBJ __AGlobSigToText_36; /* `'36 */
OBJ __AGlobSigToText_37; /* `'37 */
OBJ __AGlobSigToText_38; /* `'38 */

extern OBJ _AGlobSigToText_1(OBJ x1,OBJ x2) /* ` */
{OBJ r;
 if(ISPRM(x1)){
  CPPRD(__AGlobSigToText_15,1);
  r=__AGlobSigToText_15;
 }else{
  COPY(x1,8);
  {OBJ x1262;OBJ x1263;OBJ x1264;OBJ x1265;OBJ x1266;OBJ x1267;OBJ x1268;OBJ x1269;
   x1262=_AGlobSig_58(x1);
   x1263=_AGlobSig_57(x1);
   x1264=_AGlobSig_56(x1);
   x1265=_AGlobSig_55(x1);
   x1266=_AGlobSig_52(x1);
   x1267=_AGlobSig_46(x1);
   x1268=_AGlobSig_51(x1);
   x1269=_AGlobSig_50(x1);
   if(ISTGPRD(x1,2)){
    {OBJ x1279=FLD(x1,10);OBJ x1280=FLD(x1,11);OBJ x1281=FLD(x1,12);
     if(EXPRD(x1,1)){
      FLD(x1,10)=NIL;FLD(x1,11)=NIL;FLD(x1,12)=NIL;DSPRD(x1);
     }else{
      COPY(x1279,1);COPY(x1280,1);COPY(x1281,1);
      FRPRD(x1,1);}
     CPCLS(__AGlobSigToText_5,1);
     CPCLS(__ADeclEntry_34,1);
     CPCLS(__AImpExpEntry_138,1);
     CPPRD(__ARep_187,3);
     {OBJ x1284;OBJ x1285;OBJ x1286;
      x1284=_ATable_17(__ARep_187,__AGlobSigToText_5,x1266);
      x1285=_ATable_17(__ARep_187,__AImpExpEntry_138,x1265);
      x1286=_ATable_17(__ARep_187,__ADeclEntry_34,x1264);
      {OBJ x1288=FLD1(x1262,2);
       if(EXPRD(x1262,1)){
	DSPRDF(x1262);
       }else{
	CPPRD(x1288,1);
	FRPRD(x1262,1);}
       {OBJ x1293;OBJ x1297;OBJ x1300;OBJ x1303;OBJ x1304;OBJ x1305;OBJ x1306;OBJ x1307;OBJ x1311;OBJ x1308;OBJ x1309;OBJ x1316;OBJ x1312;OBJ x1322;OBJ x1317;OBJ x1338;OBJ x1332;OBJ x1323;OBJ x1324;OBJ x1339;OBJ x1340;OBJ x1341;OBJ x1342;OBJ x1343;OBJ x1344;OBJ x1345;OBJ x1346;OBJ x1348;OBJ x1349;OBJ x1350;OBJ x1351;OBJ x1352;OBJ x1353;
	if(ISPRM(x1269)){
	 x1293=__ABUILTIN_5;
	}else{
	 x1293=__ABUILTIN_3;}
	if(ISPRM(x1268)){
	 x1297=__ABUILTIN_5;
	}else{
	 x1297=__ABUILTIN_3;}
	if(ISPRM(x1267)){
	 x1300=__ABUILTIN_5;
	}else{
	 x1300=__ABUILTIN_3;}
	if(ISPRM(x1263)){
	 CPPRD(__AGlobSigToText_16,1);
	 CPPRD(__AGlobSigToText_17,1);
	 CPPRD(__AGlobSigToText_18,1);
	 CPPRD(__AGlobSigToText_19,1);
	 x1303=__ABUILTIN_5;
	}else{
	 CPPRD(__AGlobSigToText_16,1);
	 CPPRD(__AGlobSigToText_17,1);
	 CPPRD(__AGlobSigToText_18,1);
	 CPPRD(__AGlobSigToText_19,1);
	 x1303=__ABUILTIN_3;}
	ADenotation_4(x1288,__AGlobSigToText_19,x1304);
	ADenotation_4(__AGlobSigToText_18,x1286,x1305);
	ADenotation_4(__AGlobSigToText_17,x1285,x1306);
	ADenotation_4(__AGlobSigToText_16,x1284,x1307);
	if(ISTGPRM(x1303,1)){
	 FREE(x1263,1);
	 CPPRD(__AGlobSigToText_20,1);
	 CPPRD(__AGlobSigToText_22,1);
	 x1311=__AGlobSigToText_20;
	}else{
	 CPCLS(__AGlobSigToText_4,1);
	 CPPRD(__AGlobSigToText_19,3);
	 CPPRD(__AGlobSigToText_21,1);
	 CPPRD(__AGlobSigToText_22,1);
	 {OBJ x1310;
	  x1310=_ASeqConv_3(__AGlobSigToText_19,__AGlobSigToText_19,__AGlobSigToText_19,__AGlobSigToText_4,x1263);
	  ADenotation_4(__AGlobSigToText_21,x1310,x1311);}}
	ADenotation_4(x1305,x1306,x1308);
	ADenotation_4(__AGlobSigToText_22,x1304,x1309);
	if(ISTGPRM(x1300,1)){
	 FREE(x1267,1);
	 CPPRD(__ARep_187,1);
	 x1316=__ARep_187;
	}else{
	 CPPRD(__AGlobSigToText_19,3);
	 CPCLS(__AGlobSigToText_23,1);
	 CPPRD(__AGlobSigToText_24,1);
	 CPPRD(__ARep_187,1);
	 {OBJ x1313;OBJ x1314;OBJ x1315;
	  x1313=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_23,1))(__AGlobSigToText_23,__ABUILTIN_20);
	  x1314=_ASeqConv_3(__ARep_187,__AGlobSigToText_19,__AGlobSigToText_19,x1313,x1267);
	  ADenotation_4(x1314,__AGlobSigToText_19,x1315);
	  ADenotation_4(__AGlobSigToText_24,x1315,x1316);}}
	ADenotation_4(x1311,x1308,x1312);
	if(ISTGPRM(x1297,1)){
	 FREE(x1268,1);
	 CPPRD(__ARep_187,1);
	 x1322=__ARep_187;
	}else{
	 CPPRD(__AGlobSigToText_19,1);
	 CPCLS(__AGlobSigToText_25,1);
	 CPPRD(__AGlobSigToText_26,1);
	 CPCLS(__ARep_12,1);
	 CPCLS(__ARep_27,1);
	 CPPRD(__AMapConv_13,1);
	 CPPRD(__AMapConv_14,1);
	 CPPRD(__AMapConv_15,1);
	 CPPRD(__ASeqConv_8,1);
	 {OBJ x1319;OBJ x1320;OBJ x1321;
	  x1319=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_25,1))(__AGlobSigToText_25,__ABUILTIN_20);
	  x1320=_AMapConv_8(__ARep_27,__AMapConv_13,__AMapConv_14,__ASeqConv_8,__AMapConv_15,__ARep_12,x1319,x1268);
	  ADenotation_4(x1320,__AGlobSigToText_19,x1321);
	  ADenotation_4(__AGlobSigToText_26,x1321,x1322);}}
	ADenotation_4(x1309,x1312,x1317);
	if(ISTGPRM(x1293,1)){
	 FREE(x1269,1);
	 CPPRD(__ARep_187,1);
	 x1338=__ARep_187;
	}else{
	 CPPRD(__AGlobSigToText_19,1);
	 CPCLS(__AGlobSigToText_29,1);
	 CPPRD(__AGlobSigToText_30,1);
	 CPCLS(__ARep_12,1);
	 CPCLS(__ARep_27,1);
	 CPPRD(__AMapConv_13,1);
	 CPPRD(__AMapConv_14,1);
	 CPPRD(__AMapConv_15,1);
	 CPPRD(__ASeqConv_8,1);
	 {OBJ x1335;OBJ x1336;OBJ x1337;
	  x1335=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_29,1))(__AGlobSigToText_29,__ABUILTIN_20);
	  x1336=_AMapConv_8(__ARep_27,__AMapConv_13,__AMapConv_14,__ASeqConv_8,__AMapConv_15,__ARep_12,x1335,x1269);
	  ADenotation_4(x1336,__AGlobSigToText_19,x1337);
	  ADenotation_4(__AGlobSigToText_30,x1337,x1338);}}
	if(ISPRM(x1281)){
	 CPPRD(__AGlobSigToText_12,1);
	 CPPRD(__AGlobSigToText_19,1);
	 CPPRD(__AGlobSigToText_32,1);
	 CPPRD(__AGlobSigToText_33,1);
	 CPPRD(__AGlobSigToText_38,1);
	 CPPRD(__ARep_187,4);
	 x1332=__ARep_187;
	}else{
	 CPPRD(__AGlobSigToText_12,1);
	 CPPRD(__AGlobSigToText_19,2);
	 CPCLS(__AGlobSigToText_28,1);
	 CPPRD(__AGlobSigToText_31,1);
	 CPPRD(__AGlobSigToText_32,1);
	 CPPRD(__AGlobSigToText_33,1);
	 CPPRD(__AGlobSigToText_38,1);
	 CPCLS(__ARep_12,1);
	 CPCLS(__ARep_27,1);
	 CPPRD(__ARep_187,3);
	 CPPRD(__AMapConv_13,1);
	 CPPRD(__AMapConv_14,1);
	 CPPRD(__AMapConv_15,1);
	 CPPRD(__ASeqConv_8,1);
	 {OBJ x1329;OBJ x1330;OBJ x1331;
	  x1329=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_28,1))(__AGlobSigToText_28,__ABUILTIN_20);
	  x1330=_AMapConv_8(__ARep_27,__AMapConv_13,__AMapConv_14,__ASeqConv_8,__AMapConv_15,__ARep_12,x1329,x1281);
	  ADenotation_4(x1330,__AGlobSigToText_19,x1331);
	  ADenotation_4(__AGlobSigToText_31,x1331,x1332);}}
	ADenotation_4(x1316,x1322,x1323);
	ADenotation_4(__AGlobSigToText_32,x1317,x1324);
	ADenotation_4(x1338,__AGlobSigToText_33,x1339);
	ADenotation_4(x1332,x1323,x1340);
	x1341=_AName_34(x1280);
	x1342=_AName_34(x1279);
	ADenotation_4(x1341,__AGlobSigToText_19,x1343);
	ADenotation_4(__AGlobSigToText_12,x1343,x1344);
	ADenotation_4(x1342,x1344,x1345);
	ADenotation_4(__AGlobSigToText_38,x1345,x1346);
	ADenotation_4(__ARep_187,x1307,x1348);
	ADenotation_4(__ARep_187,x1348,x1349);
	ADenotation_4(x1346,x1340,x1350);
	ADenotation_4(x1350,x1339,x1351);
	ADenotation_4(x1349,x1351,x1352);
	ADenotation_4(__ARep_187,x1352,x1353);
	ADenotation_4(x1324,x1353,r);}}}}
   }else{
    {OBJ x1360=FLD(x1,7);OBJ x1361=FLD(x1,8);OBJ x1362=FLD(x1,9);OBJ x1366=FLD(x1,13);OBJ x1367=FLD(x1,14);OBJ x1368=FLD(x1,15);OBJ x1369=FLD(x1,16);
     if(EXPRD(x1,1)){
      FLD(x1,7)=NIL;FLD(x1,8)=NIL;FLD(x1,9)=NIL;FLD(x1,13)=NIL;FLD(x1,14)=NIL;FLD(x1,15)=NIL;FLD(x1,16)=NIL;DSPRD(x1);
     }else{
      CPPRD(x1360,1);CPPRD(x1361,1);CPPRD(x1362,1);CPPRD(x1366,1);CPPRD(x1367,1);CPPRD(x1368,1);CPPRD(x1369,1);
      FRPRD(x1,1);}
     CPCLS(__AGlobSigToText_5,1);
     CPCLS(__ADeclEntry_34,1);
     CPCLS(__AImpExpEntry_138,1);
     CPPRD(__ARep_187,3);
     {OBJ x1371;OBJ x1372;OBJ x1373;
      x1371=_ATable_17(__ARep_187,__ADeclEntry_34,x1264);
      x1372=_ATable_17(__ARep_187,__AImpExpEntry_138,x1265);
      x1373=_ATable_17(__ARep_187,__AGlobSigToText_5,x1266);
      {OBJ x1375=FLD1(x1262,2);
       if(EXPRD(x1262,1)){
	DSPRDF(x1262);
       }else{
	CPPRD(x1375,1);
	FRPRD(x1262,1);}
       {OBJ x1380;OBJ x1384;OBJ x1387;OBJ x1390;OBJ x1391;OBJ x1392;OBJ x1393;OBJ x1394;OBJ x1398;OBJ x1395;OBJ x1396;OBJ x1403;OBJ x1399;OBJ x1409;OBJ x1404;OBJ x1417;OBJ x1410;OBJ x1411;OBJ x1418;OBJ x1419;OBJ x1420;OBJ x1421;OBJ x1422;
	if(ISPRM(x1269)){
	 x1380=__ABUILTIN_5;
	}else{
	 x1380=__ABUILTIN_3;}
	if(ISPRM(x1268)){
	 x1384=__ABUILTIN_5;
	}else{
	 x1384=__ABUILTIN_3;}
	if(ISPRM(x1267)){
	 x1387=__ABUILTIN_5;
	}else{
	 x1387=__ABUILTIN_3;}
	if(ISPRM(x1263)){
	 CPPRD(__AGlobSigToText_16,1);
	 CPPRD(__AGlobSigToText_17,1);
	 CPPRD(__AGlobSigToText_18,1);
	 CPPRD(__AGlobSigToText_19,1);
	 x1390=__ABUILTIN_5;
	}else{
	 CPPRD(__AGlobSigToText_16,1);
	 CPPRD(__AGlobSigToText_17,1);
	 CPPRD(__AGlobSigToText_18,1);
	 CPPRD(__AGlobSigToText_19,1);
	 x1390=__ABUILTIN_3;}
	ADenotation_4(__AGlobSigToText_16,x1373,x1391);
	ADenotation_4(__AGlobSigToText_17,x1372,x1392);
	ADenotation_4(__AGlobSigToText_18,x1371,x1393);
	ADenotation_4(x1375,__AGlobSigToText_19,x1394);
	if(ISTGPRM(x1390,1)){
	 FREE(x1263,1);
	 CPPRD(__AGlobSigToText_20,1);
	 CPPRD(__AGlobSigToText_22,1);
	 x1398=__AGlobSigToText_20;
	}else{
	 CPCLS(__AGlobSigToText_4,1);
	 CPPRD(__AGlobSigToText_19,3);
	 CPPRD(__AGlobSigToText_21,1);
	 CPPRD(__AGlobSigToText_22,1);
	 {OBJ x1397;
	  x1397=_ASeqConv_3(__AGlobSigToText_19,__AGlobSigToText_19,__AGlobSigToText_19,__AGlobSigToText_4,x1263);
	  ADenotation_4(__AGlobSigToText_21,x1397,x1398);}}
	ADenotation_4(__AGlobSigToText_22,x1394,x1395);
	ADenotation_4(x1393,x1392,x1396);
	if(ISTGPRM(x1387,1)){
	 FREE(x1267,1);
	 CPPRD(__ARep_187,1);
	 x1403=__ARep_187;
	}else{
	 CPPRD(__AGlobSigToText_19,3);
	 CPCLS(__AGlobSigToText_23,1);
	 CPPRD(__AGlobSigToText_24,1);
	 CPPRD(__ARep_187,1);
	 {OBJ x1400;OBJ x1401;OBJ x1402;
	  x1400=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_23,1))(__AGlobSigToText_23,__ABUILTIN_20);
	  x1401=_ASeqConv_3(__ARep_187,__AGlobSigToText_19,__AGlobSigToText_19,x1400,x1267);
	  ADenotation_4(x1401,__AGlobSigToText_19,x1402);
	  ADenotation_4(__AGlobSigToText_24,x1402,x1403);}}
	ADenotation_4(x1398,x1396,x1399);
	if(ISTGPRM(x1384,1)){
	 FREE(x1268,1);
	 CPPRD(__ARep_187,1);
	 x1409=__ARep_187;
	}else{
	 CPPRD(__AGlobSigToText_19,1);
	 CPCLS(__AGlobSigToText_25,1);
	 CPPRD(__AGlobSigToText_26,1);
	 CPCLS(__ARep_12,1);
	 CPCLS(__ARep_27,1);
	 CPPRD(__AMapConv_13,1);
	 CPPRD(__AMapConv_14,1);
	 CPPRD(__AMapConv_15,1);
	 CPPRD(__ASeqConv_8,1);
	 {OBJ x1406;OBJ x1407;OBJ x1408;
	  x1406=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_25,1))(__AGlobSigToText_25,__ABUILTIN_20);
	  x1407=_AMapConv_8(__ARep_27,__AMapConv_13,__AMapConv_14,__ASeqConv_8,__AMapConv_15,__ARep_12,x1406,x1268);
	  ADenotation_4(x1407,__AGlobSigToText_19,x1408);
	  ADenotation_4(__AGlobSigToText_26,x1408,x1409);}}
	ADenotation_4(x1395,x1399,x1404);
	if(ISTGPRM(x1380,1)){
	 FREE(x1269,1);
	 CPCLS(__AGlobSigToText_3,1);
	 CPPRD(__AGlobSigToText_32,1);
	 CPPRD(__AGlobSigToText_33,1);
	 CPCLS(__APartNameEntry_54,1);
	 CPCLS(__APartNameEntry_55,1);
	 CPCLS(__APartNameEntry_56,1);
	 CPCLS(__APartNameEntry_57,1);
	 CPPRD(__ARep_187,5);
	 x1417=__ARep_187;
	}else{
	 CPCLS(__AGlobSigToText_3,1);
	 CPPRD(__AGlobSigToText_19,1);
	 CPCLS(__AGlobSigToText_29,1);
	 CPPRD(__AGlobSigToText_30,1);
	 CPPRD(__AGlobSigToText_32,1);
	 CPPRD(__AGlobSigToText_33,1);
	 CPCLS(__APartNameEntry_54,1);
	 CPCLS(__APartNameEntry_55,1);
	 CPCLS(__APartNameEntry_56,1);
	 CPCLS(__APartNameEntry_57,1);
	 CPCLS(__ARep_12,1);
	 CPCLS(__ARep_27,1);
	 CPPRD(__ARep_187,4);
	 CPPRD(__AMapConv_13,1);
	 CPPRD(__AMapConv_14,1);
	 CPPRD(__AMapConv_15,1);
	 CPPRD(__ASeqConv_8,1);
	 {OBJ x1414;OBJ x1415;OBJ x1416;
	  x1414=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_29,1))(__AGlobSigToText_29,__ABUILTIN_20);
	  x1415=_AMapConv_8(__ARep_27,__AMapConv_13,__AMapConv_14,__ASeqConv_8,__AMapConv_15,__ARep_12,x1414,x1269);
	  ADenotation_4(x1415,__AGlobSigToText_19,x1416);
	  ADenotation_4(__AGlobSigToText_30,x1416,x1417);}}
	ADenotation_4(__AGlobSigToText_32,x1404,x1410);
	ADenotation_4(x1403,x1409,x1411);
	ADenotation_4(__ARep_187,x1411,x1418);
	ADenotation_4(x1417,__AGlobSigToText_33,x1419);
	x1420=_AUniqueTable_20(__APartNameEntry_54,__ARep_187,__APartNameEntry_56,x1360);
	x1421=_AUniqueTable_20(__APartNameEntry_55,__ARep_187,__APartNameEntry_57,x1361);
	x1422=_ATable_17(__ARep_187,__AGlobSigToText_3,x1362);
	{OBJ x1424=FLD1(x1366,2);
	 if(EXPRD(x1366,1)){
	  DSPRDF(x1366);
	 }else{
	  CPPRD(x1424,1);
	  FRPRD(x1366,1);}
	 {OBJ x1427=FLD1(x1367,2);
	  if(EXPRD(x1367,1)){
	   DSPRDF(x1367);
	  }else{
	   CPPRD(x1427,1);
	   FRPRD(x1367,1);}
	  {OBJ x1430=FLD1(x1368,2);
	   if(EXPRD(x1368,1)){
	    DSPRDF(x1368);
	   }else{
	    CPPRD(x1430,1);
	    FRPRD(x1368,1);}
	   {OBJ x1433=FLD1(x1369,2);
	    if(EXPRD(x1369,1)){
	     DSPRDF(x1369);
	    }else{
	     CPPRD(x1433,1);
	     FRPRD(x1369,1);}
	    CPPRD(__AGlobSigToText_12,3);
	    CPPRD(__AGlobSigToText_19,1);
	    CPPRD(__AGlobSigToText_34,1);
	    CPPRD(__AGlobSigToText_35,1);
	    CPPRD(__AGlobSigToText_36,1);
	    CPPRD(__AGlobSigToText_37,1);
	    {OBJ x1435;OBJ x1436;OBJ x1437;OBJ x1438;OBJ x1439;OBJ x1440;OBJ x1441;OBJ x1442;OBJ x1443;OBJ x1444;OBJ x1445;OBJ x1447;OBJ x1448;OBJ x1449;OBJ x1450;OBJ x1451;OBJ x1452;
	     ADenotation_4(x1433,__AGlobSigToText_19,x1435);
	     ADenotation_4(__AGlobSigToText_36,x1422,x1436);
	     ADenotation_4(__AGlobSigToText_35,x1421,x1437);
	     ADenotation_4(__AGlobSigToText_34,x1420,x1438);
	     ADenotation_4(__AGlobSigToText_12,x1435,x1439);
	     ADenotation_4(x1430,x1439,x1440);
	     ADenotation_4(__AGlobSigToText_12,x1440,x1441);
	     ADenotation_4(x1427,x1441,x1442);
	     ADenotation_4(__AGlobSigToText_12,x1442,x1443);
	     ADenotation_4(x1424,x1443,x1444);
	     ADenotation_4(__AGlobSigToText_37,x1444,x1445);
	     ADenotation_4(x1436,x1391,x1447);
	     ADenotation_4(x1437,x1447,x1448);
	     ADenotation_4(x1445,x1418,x1449);
	     ADenotation_4(x1449,x1419,x1450);
	     ADenotation_4(x1448,x1450,x1451);
	     ADenotation_4(x1438,x1451,x1452);
	     ADenotation_4(x1410,x1452,r);}}}}}}}}}}}}
 return r;}

extern OBJ _AGlobSigToText_2(OBJ x1) /* `_l */
{OBJ r;
 r=_AGlobSigToText_5(x1);
 return r;}

extern OBJ _AGlobSigToText_3(OBJ x1) /* `,1 */
{OBJ r;
 {OBJ x5=FLD1(x1,3);
  CPPRD(x5,1);
  CPPRD(__AGlobSigToText_6,1);
  CPPRD(__AGlobSigToText_7,1);
  CPPRD(__AGlobSigToText_8,1);
  CPCLS(__APartNameEntry_60,1);
  CPPRD(__APairConv_7,1);
  {OBJ x6;OBJ x7;OBJ x8;TUP2 x9;OBJ x11;OBJ x12;OBJ x13;OBJ x14;OBJ x15;
   x6=x5;
   x7=_ATable_17(__AGlobSigToText_7,__APartNameEntry_60,x6);
   ADenotation_4(__APairConv_7,x7,x8);
   x9=_AGlobSig_97(x1);
   ANatConv_1(x9.c1,x11);
   ANatConv_1(x9.c2,x12);
   ADenotation_4(x12,x8,x13);
   ADenotation_4(__AGlobSigToText_6,x13,x14);
   ADenotation_4(x11,x14,x15);
   ADenotation_4(__AGlobSigToText_8,x15,r);}}
 return r;}

extern OBJ _AGlobSigToText_4(OBJ x1) /* `,2 */
{OBJ r;
 CPPRD(x1,1);
 {OBJ x2;
  x2=_AGlobSig_95(x1);
  if(ISTGPRM(x2,1)){
   {OBJ x3;
    x3=_AGlobSig_93(x1);
    {OBJ x12=FLD1(x3,1);OBJ x13=FLD1(x3,2);
     if(EXPRD(x3,1)){
      DSPRDF(x3);
     }else{
      CPPRD(x12,1);COPY(x13,1);
      FRPRD(x3,1);}
     {OBJ x14;OBJ x15;
      x14=_APragma_10(x13);
      x15=_APartNameEntry_60(x12);
      ADenotation_4(x15,x14,r);}}}
  }else{
   {OBJ x67=FLD1(x1,1);OBJ x68=FLD1(x1,2);OBJ x69=FLD1(x1,3);
    COPY(x67,1);COPY(x68,1);COPY(x69,1);
    if(ISPRM(x67)){
     FREE(x68,1);
     FREE(x69,1);
     {OBJ x70;
      x70=_AGlobSig_94(x1);
      {OBJ x71=FLD1(x70,1);OBJ x72=FLD1(x70,2);
       if(EXPRD(x70,1)){
	DSPRDF(x70);
       }else{
	COPY(x72,1);
	FRPRD(x70,1);}
       {OBJ x73;OBJ x74;
	x73=_APragma_10(x72);
	ANatConv_1(x71,x74);
	ADenotation_4(x74,x73,r);}}}
    }else{
     {OBJ x75=FLD1(x67,1);
      if(EXPRD(x67,1)){
       DSPRDF(x67);
      }else{
       CPPRD(x75,1);
       FRPRD(x67,1);}
      if(EXPRD(x1,1)){
       DSPRD(x1);
      }else{
       DCPRD(x1,1);}
      {OBJ x78;OBJ x76;OBJ x79;OBJ x80;OBJ x81;OBJ x82;OBJ x83;
       if(ISPRM(x68)){
	HLT("Option at <unknown> : undefined selection cont\'Option:option->data");
       }else{
	{OBJ x77=FLD1(x68,1);
	 if(EXPRD(x68,1)){
	  x78=x77;
	  DSPRDF(x68);
	 }else{
	  x78=x77;
	  FRPRD(x68,1);}
	 CPPRD(__APairConv_5,1);
	 CPPRD(__APairConv_7,1);}}
       x76=_APragma_10(x69);
       x79=_APartNameEntry_60(x75);
       ANatConv_1(x78,x80);
       ADenotation_4(__APairConv_7,x76,x81);
       ADenotation_4(x80,x81,x82);
       ADenotation_4(__APairConv_5,x82,x83);
       ADenotation_4(x79,x83,r);}}}}}}
 return r;}

extern OBJ _AGlobSigToText_5(OBJ x1) /* `,3 */
{OBJ r;
 CPCLS(__AGlobSigToText_9,1);
 CPCLS(__AGlobSigToText_10,1);
 {OBJ x32;OBJ x33;
  x32=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_9,1))(__AGlobSigToText_9,__ABUILTIN_20);
  x33=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_10,1))(__AGlobSigToText_10,__ABUILTIN_20);
  {OBJ x49=FLD1(x1,1);OBJ x50=FLD1(x1,2);OBJ x51=FLD1(x1,3);OBJ x52=FLD1(x1,4);OBJ x53=FLD1(x1,5);
   if(EXPRD(x1,1)){
    DSPRDF(x1);
   }else{
    COPY(x49,1);COPY(x50,1);COPY(x51,1);COPY(x52,1);COPY(x53,1);
    FRPRD(x1,1);}
   CPCLS(x33,1);
   CPPRD(__AGlobSigToText_6,4);
   CPCLS(__AGlobSigToText_14,1);
   {OBJ x55;OBJ x56;OBJ x57;OBJ x58;OBJ x59;OBJ x60;OBJ x61;OBJ x62;OBJ x63;OBJ x64;OBJ x65;OBJ x66;OBJ x67;
    x55=_ASeqConv_2(x33,x51);
    x56=_ASeqConv_2(x33,x50);
    x57=_AOptionConv_2(x32,x49);
    x58=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_14,1))(__AGlobSigToText_14,__ABUILTIN_20);
    CPCLS(x58,1);
    ADenotation_4(__AGlobSigToText_6,x56,x59);
    x60=_ASeqConv_2(x58,x53);
    x61=_ASeqConv_2(x58,x52);
    ADenotation_4(x57,x59,x62);
    ADenotation_4(__AGlobSigToText_6,x60,x63);
    ADenotation_4(__AGlobSigToText_6,x61,x64);
    ADenotation_4(x55,x64,x65);
    ADenotation_4(x65,x63,x66);
    ADenotation_4(__AGlobSigToText_6,x66,x67);
    ADenotation_4(x62,x67,r);}}}
 return r;}

extern OBJ _AGlobSigToText_9(OBJ x1) /* `,3'9 */
{OBJ r;
 CPCLS(__AObjects_18,1);
 CPCLS(__ANatConv_1,1);
 CPCLS(__ACompose_4,1);
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ACompose_4,2))(__ACompose_4,__ANatConv_1,__AObjects_18);
 return r;}

extern OBJ _AGlobSigToText_10(OBJ x1) /* `,3'10 */
{OBJ r;
 CPCLS(__AObjects_26,1);
 CPCLS(__ANatConv_1,1);
 CPCLS(__ACompose_4,1);
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ACompose_4,2))(__ACompose_4,__ANatConv_1,__AObjects_26);
 return r;}

extern OBJ _AGlobSigToText_11(OBJ x1) /* `,3'11 */
{OBJ r;
 CPCLS(__AObjects_22,1);
 CPCLS(__ANatConv_1,1);
 CPCLS(__ACompose_4,1);
 r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ACompose_4,2))(__ACompose_4,__ANatConv_1,__AObjects_22);
 return r;}

extern OBJ _AGlobSigToText_13(OBJ x1) /* `,3'13 */
{OBJ r;
 CPCLS(__AGlobSigToText_11,1);
 CPPRD(__AGlobSigToText_12,1);
 CPPRD(__ARep_187,2);
 CPCLS(__ASeqConv_3,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_11,1))(__AGlobSigToText_11,__ABUILTIN_20);
  r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__ASeqConv_3,4))(__ASeqConv_3,__ARep_187,__AGlobSigToText_12,__ARep_187,x2);}
 return r;}

extern OBJ _AGlobSigToText_14(OBJ x1) /* `,3'14 */
{OBJ r;
 CPCLS(__AGlobSigToText_9,1);
 CPCLS(__AGlobSigToText_13,1);
 CPCLS(__APairConv_3,1);
 {OBJ x2;OBJ x3;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_9,1))(__AGlobSigToText_9,__ABUILTIN_20);
  x3=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_13,1))(__AGlobSigToText_13,__ABUILTIN_20);
  r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__APairConv_3,2))(__APairConv_3,x2,x3);}
 return r;}

extern OBJ _AGlobSigToText_23(OBJ x1) /* `'23 */
{OBJ r;
 CPCLS(__AName_34,1);
 CPCLS(__AGlobPragma_14,1);
 r=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobPragma_14,1))(__AGlobPragma_14,__AName_34);
 return r;}

extern OBJ _AGlobSigToText_25(OBJ x1) /* `'25 */
{OBJ r;
 CPCLS(__AGlobSigToText_23,1);
 CPCLS(__ASeqConv_2,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_23,1))(__AGlobSigToText_23,__ABUILTIN_20);
  r=(*(OBJ(*)(OBJ,OBJ))METHOD(__ASeqConv_2,1))(__ASeqConv_2,x2);}
 return r;}

extern OBJ _AGlobSigToText_27(OBJ x1) /* `'27 */
{OBJ r;
 CPCLS(__AName_34,1);
 CPCLS(__AImpl_186,1);
 r=(*(OBJ(*)(OBJ,OBJ))METHOD(__AImpl_186,1))(__AImpl_186,__AName_34);
 return r;}

extern OBJ _AGlobSigToText_28(OBJ x1) /* `'28 */
{OBJ r;
 CPCLS(__AGlobSigToText_27,1);
 CPCLS(__AGlobSigImpl_31,1);
 CPCLS(__APairConv_3,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_27,1))(__AGlobSigToText_27,__ABUILTIN_20);
  r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__APairConv_3,2))(__APairConv_3,x2,__AGlobSigImpl_31);}
 return r;}

extern OBJ _AGlobSigToText_29(OBJ x1) /* `'29 */
{OBJ r;
 CPCLS(__AGlobSigToText_28,1);
 CPCLS(__ASeqConv_2,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AGlobSigToText_28,1))(__AGlobSigToText_28,__ABUILTIN_20);
  r=(*(OBJ(*)(OBJ,OBJ))METHOD(__ASeqConv_2,1))(__ASeqConv_2,x2);}
 return r;}

static OBJ _mt_1_0_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 {OBJ t3;
  DCCLS(t,1);
  t3=(*(OBJ(*)(OBJ))ENTRY(t))(t1);
  r=(*(OBJ(*)(OBJ,OBJ))METHOD(t3,1))(t3,t2);}
 return r;}

init_AGlobSigToText()
{
 static int visited=0; if(visited) return; visited=1;
 init_APartName();
 init_ADenotation();
 init_ANatConv();
 init_ACompose();
 init_AGlobSig();
 init_AOptionConv();
 init_ATable();
 init_APairConv();
 init_AUniqueTable();
 init_AMapConv();
 init_ADeclEntry();
 init_ASeqConv();
 init_APartNameEntry();
 init_AInt();
 init_AImpExpEntry();
 init_AReal();
 init_AObjects();
 init_ASetByBST();
 init_AName();
 init_ABSTree();
 init_AGlobSigImpl();
 init_ATree();
 init_ARep();
 init_ADArrayReduce();
 init_APragma();
 init_ALexem();
 init_AImpl();
 init_ASeqReduce();
 init_AGlobPragma();
 init_AOcPos();
 init_AOption();
 init_APair();
 init_ASeq();
 init_ANat();
 init_AMap();
 init_ASet();
 init_AChar();
 init_AFct();
 init_ABitset();
 init_APatterns();
 init_AAttributes();
 init_ADArray();
 init_ANatMap();
 init_AString();
 init_AArray();
 DEN("Laws ...\n",__AGlobSigToText_31);
 DEN("ImpLaws ...\n",__AGlobSigToText_30);
 LCLS(1,_AGlobSigToText_29,__AGlobSigToText_29);
 LCLS(1,_AGlobSigToText_28,__AGlobSigToText_28);
 LCLS(1,_AGlobSigToText_27,__AGlobSigToText_27);
 DEN("ImpPragmas ...\n",__AGlobSigToText_26);
 LCLS(1,_AGlobSigToText_25,__AGlobSigToText_25);
 DEN("Global pragmas ...\n",__AGlobSigToText_24);
 LCLS(1,_AGlobSigToText_23,__AGlobSigToText_23);
 DEN("Structure name: ",__AGlobSigToText_22);
 DEN("Formal parameters ...",__AGlobSigToText_21);
 DEN("unparamterized\n",__AGlobSigToText_20);
 DEN("\n",__AGlobSigToText_19);
 DEN("Declarations ...\n",__AGlobSigToText_18);
 DEN("\nImported Structures ...\n",__AGlobSigToText_17);
 DEN("\nLookup table ...\n",__AGlobSigToText_16);
 DEN("************ erroneous global signature ************\n",__AGlobSigToText_15);
 LCLS(1,_AGlobSigToText_14,__AGlobSigToText_14);
 LCLS(1,_AGlobSigToText_13,__AGlobSigToText_13);
 DEN(" ",__AGlobSigToText_12);
 LCLS(1,_AGlobSigToText_11,__AGlobSigToText_11);
 LCLS(1,_AGlobSigToText_10,__AGlobSigToText_10);
 LCLS(1,_AGlobSigToText_9,__AGlobSigToText_9);
 DEN("\n(",__AGlobSigToText_8);
 DEN("  ",__AGlobSigToText_7);
 DEN("Identifier of implicit objects: ",__AGlobSigToText_38);
 DEN(",",__AGlobSigToText_6);
 DEN("Identifier of implicit imports: ",__AGlobSigToText_37);
 CLS(1,_AGlobSigToText_5,__AGlobSigToText_5);
 DEN("\nTable of all only-tables ...\n",__AGlobSigToText_36);
 CLS(1,_AGlobSigToText_4,__AGlobSigToText_4);
 DEN("\nApplications in instanzes ...\n",__AGlobSigToText_35);
 CLS(1,_AGlobSigToText_3,__AGlobSigToText_3);
 DEN("\nApplications of sorts ...\n",__AGlobSigToText_34);
 CLS(1,_AGlobSigToText_2,__AGlobSigToText_2);
 DEN("************ end of global signature ************\n",__AGlobSigToText_33);
 LCLS(2,_AGlobSigToText_1,__AGlobSigToText_1);
 DEN("************ begin of global signature *************\n",__AGlobSigToText_32);
 MTH(1,0,2,_mt_1_0_2);LZYMTH(1,0,2,_mt_1_0_2);}

